-- Load LuaSocket library
--socket = require("socket")

-- Create a UDP socket
--udp = socket.udp4()
--udp:settimeout(0)

-- Set the destination IP address and port
local address, port = "127.0.0.1", 1024

--local address, port = "::1", 1024

--udp:setpeername(address, port)

math.randomseed(os.time()) 
	entity = tostring(math.random(99999))

-- Define variables to store received axis values
receivedLeftXAxis = 0
receivedLeftYAxis = 0
receivedRightXAxis = 0
receivedRightYAxis = 0

function receiveThumbstickAxes()
  -- Print a message to indicate that the function is called
  --print("Receiving thumbstick axes...")

  -- Attempt to receive data from the UDP socket
  --data, address, port = udp:receivefrom()
  data, address, port = udp:receivefrom()
  
  --local data = udp:receivefrom()

  -- Print the received IP address and port for debugging
  --print("Received from IP:", address)
  --print("Received from Port:", port)
	--print("Received data:", data)

  -- Check if data is received
  if data then
    --print("Received data:", data)

    -- Deserialize the received data
    local values = {}
    for value in string.gmatch(data, "([^,]+)") do
      table.insert(values, tonumber(value))
    end

    -- Print the parsed values for debugging
    --print("Parsed values:", unpack(values))

    -- Update thumbstick axes based on the received data
    if #values >= 2 then
      receivedLeftXAxis = normalizeAxisValue(values[1])
      receivedLeftYAxis = normalizeAxisValue(values[2])
      --print("Updated Left Thumbstick Axes - X:", receivedLeftXAxis, "Y:", receivedLeftYAxis)
    end

    if #values >= 4 then
      receivedRightXAxis = normalizeAxisValue(values[3])
      receivedRightYAxis = normalizeAxisValue(values[4])
      --print("Updated Right Thumbstick Axes - X:", receivedRightXAxis, "Y:", receivedRightYAxis)
    end
  else
    -- Print a message if no data is received
    print("No data received.")
  end
end



-- Function to normalize and scale axis values to fit within the range of -1 to 1
function normalizeAxisValue(value)
  -- Assuming the range of received axis values is between 0 and 1,
  -- you can normalize and scale them to fit within the range of -1 to 1
  return (value * 2) - 1
end

